import { CommonModule } from '@angular/common';
import { InjectionToken, NgModule, Injectable, Inject, ɵɵdefineInjectable, ɵɵinject } from '@angular/core';
import Code from '@editorjs/code';
import Header from '@editorjs/header';
import Image from '@editorjs/image';
import Link from '@editorjs/link';
import List from '@editorjs/list';
import Marker from '@editorjs/paragraph';
import SimpleImage from '@editorjs/simple-image';
import { __assign, __read } from 'tslib';
import InlineCode from '@editorjs/inline-code';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var PluginTypes = {
    /**
     * A EditorJS block plugin
     */
    Block: 'block',
    /**
     * A EditorJS inline plugin
     */
    Inline: 'inline',
};
/**
 * The Injection token for initial plugins as defined in the ngx-editorjs module
 * @type {?}
 */
var EDITOR_JS_TOOL_INJECTOR = new InjectionToken('EDITOR_JS_TOOL_INJECTOR');
/**
 * Injection token for a plugin config
 * @type {?}
 */
var PLUGIN_CONFIG = new InjectionToken('PLUGIN_CONFIG');
/**
 * Injection token for the plugin config map
 * @type {?}
 */
var PluginClasses = new InjectionToken('PluginClasses');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0 = Code, ɵ1 = {
    key: 'code',
    type: PluginTypes.Block,
    pluginName: 'EditorJS Code'
};
/**
 * A module that provides the default EditorJS `<code>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/code) for API details
 */
var PluginCodeModule = /** @class */ (function () {
    function PluginCodeModule() {
    }
    PluginCodeModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EDITOR_JS_TOOL_INJECTOR,
                            useValue: ɵ0,
                            multi: true
                        },
                        {
                            provide: PLUGIN_CONFIG,
                            useValue: ɵ1,
                            multi: true
                        }
                    ]
                },] }
    ];
    return PluginCodeModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$1 = Header, ɵ1$1 = {
    key: 'header',
    type: PluginTypes.Block,
    pluginName: 'EditorJS Header'
};
/**
 * A module that provides the default EditorJS header block tool.
 * See [the GitHub repo](https://github.com/editor-js/header) for API details
 */
var PluginHeaderModule = /** @class */ (function () {
    function PluginHeaderModule() {
    }
    PluginHeaderModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EDITOR_JS_TOOL_INJECTOR,
                            useValue: ɵ0$1,
                            multi: true
                        },
                        {
                            provide: PLUGIN_CONFIG,
                            useValue: ɵ1$1,
                            multi: true
                        }
                    ]
                },] }
    ];
    return PluginHeaderModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$2 = Image, ɵ1$2 = {
    key: 'image',
    type: PluginTypes.Block,
    pluginName: 'EditorJS Image'
};
/**
 * A module that provides the default EditorJS `<img>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/image) for API details
 */
var PluginImageModule = /** @class */ (function () {
    function PluginImageModule() {
    }
    PluginImageModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EDITOR_JS_TOOL_INJECTOR,
                            useValue: ɵ0$2,
                            multi: true
                        },
                        {
                            provide: PLUGIN_CONFIG,
                            useValue: ɵ1$2,
                            multi: true
                        }
                    ]
                },] }
    ];
    return PluginImageModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$3 = Link, ɵ1$3 = {
    key: 'link',
    type: PluginTypes.Block,
    pluginName: 'EditorJS Link'
};
/**
 * A module that provides the default EditorJS `<img>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/image) for API details
 */
var PluginLinkModule = /** @class */ (function () {
    function PluginLinkModule() {
    }
    PluginLinkModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EDITOR_JS_TOOL_INJECTOR,
                            useValue: ɵ0$3,
                            multi: true
                        },
                        {
                            provide: PLUGIN_CONFIG,
                            useValue: ɵ1$3,
                            multi: true
                        }
                    ]
                },] }
    ];
    return PluginLinkModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$4 = List, ɵ1$4 = {
    key: 'list',
    type: PluginTypes.Block,
    pluginName: 'EditorJS List'
};
/**
 * A module that provides the default EditorJS `<img>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/image) for API details
 */
var PluginListModule = /** @class */ (function () {
    function PluginListModule() {
    }
    PluginListModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EDITOR_JS_TOOL_INJECTOR,
                            useValue: ɵ0$4,
                            multi: true
                        },
                        {
                            provide: PLUGIN_CONFIG,
                            useValue: ɵ1$4,
                            multi: true
                        }
                    ]
                },] }
    ];
    return PluginListModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$5 = Marker, ɵ1$5 = {
    key: 'paragraph',
    type: PluginTypes.Inline,
    pluginName: 'EditorJS Marker',
    shortcut: 'CTRL+SHIFT+M'
};
/**
 * A module that provides the default EditorJS `<p>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
 */
var PluginMarkerModule = /** @class */ (function () {
    function PluginMarkerModule() {
    }
    PluginMarkerModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EDITOR_JS_TOOL_INJECTOR,
                            useValue: ɵ0$5,
                            multi: true
                        },
                        {
                            provide: PLUGIN_CONFIG,
                            useValue: ɵ1$5,
                            multi: true
                        }
                    ]
                },] }
    ];
    return PluginMarkerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$6 = Marker, ɵ1$6 = {
    key: 'paragraph',
    type: PluginTypes.Block,
    pluginName: 'EditorJS Paragraph'
};
/**
 * A module that provides the default EditorJS `<p>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
 */
var PluginParagraphModule = /** @class */ (function () {
    function PluginParagraphModule() {
    }
    PluginParagraphModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EDITOR_JS_TOOL_INJECTOR,
                            useValue: ɵ0$6,
                            multi: true
                        },
                        {
                            provide: PLUGIN_CONFIG,
                            useValue: ɵ1$6,
                            multi: true
                        }
                    ]
                },] }
    ];
    return PluginParagraphModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$7 = SimpleImage, ɵ1$7 = {
    key: 'simpleimage',
    type: PluginTypes.Block,
    pluginName: 'EditorJS Simple Image'
};
/**
 * A module that provides the default EditorJS `<img>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/image) for API details
 */
var PluginSimpleImageModule = /** @class */ (function () {
    function PluginSimpleImageModule() {
    }
    PluginSimpleImageModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EDITOR_JS_TOOL_INJECTOR,
                            useValue: ɵ0$7,
                            multi: true
                        },
                        {
                            provide: PLUGIN_CONFIG,
                            useValue: ɵ1$7,
                            multi: true
                        }
                    ]
                },] }
    ];
    return PluginSimpleImageModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Factory function to create the plugin config map for the plugin service
 * @param {?} pluginConfigs The array of plugin configuration objects passed to this factory
 * @param {?} plugins The array of `EditorJS` plugins that are passed to this factory
 * @return {?}
 */
function createPluginConfig(pluginConfigs, plugins) {
    return pluginConfigs.reduce((/**
     * @param {?} pluginConfig
     * @param {?} config
     * @param {?} index
     * @return {?}
     */
    function (pluginConfig, config, index) {
        var _a;
        return (__assign({}, pluginConfig, (_a = {}, _a[config.key] = __assign({}, config, { plugin: plugins[index] }), _a)));
    }), {});
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * The `NgxEditorJSPluginService` is provided as a root service for handling {\@link https://github.com/editor-js | EditorJS plugins}.
 *
 * Plugins are provided by using {\@link https://angular.io/api/core/NgModule | NgModule} to inject the plugin with a
 * {\@link ../interfaces/PluginConfig.html | PluginConfig} using providers.
 */
var NgxEditorJSPluginService = /** @class */ (function () {
    /**
     * @param pluginConfigMap The plugin configuration map injected into the application
     */
    function NgxEditorJSPluginService(pluginConfigMap) {
        this.pluginConfigMap = pluginConfigMap;
    }
    /**
     * Get a map of all plugin configurations
     * @returns The map of plugins injected into this plugin
     */
    /**
     * Get a map of all plugin configurations
     * @return {?} The map of plugins injected into this plugin
     */
    NgxEditorJSPluginService.prototype.getPlugins = /**
     * Get a map of all plugin configurations
     * @return {?} The map of plugins injected into this plugin
     */
    function () {
        return this.pluginConfigMap;
    };
    /**
     * Get a plugin configuration via it's key
     * @param key The key of the plugin to get
     * @returns The plugin configuration for the passed key
     */
    /**
     * Get a plugin configuration via it's key
     * @param {?} key The key of the plugin to get
     * @return {?} The plugin configuration for the passed key
     */
    NgxEditorJSPluginService.prototype.getPlugin = /**
     * Get a plugin configuration via it's key
     * @param {?} key The key of the plugin to get
     * @return {?} The plugin configuration for the passed key
     */
    function (key) {
        return this.pluginConfigMap[key];
    };
    /**
     * Get a list of plugins, filtering with an exclude list of plugins
     * @param excludeList
     */
    /**
     * Get a list of plugins, filtering with an exclude list of plugins
     * @param {?=} excludeList
     * @return {?}
     */
    NgxEditorJSPluginService.prototype.getPluginsWithExclude = /**
     * Get a list of plugins, filtering with an exclude list of plugins
     * @param {?=} excludeList
     * @return {?}
     */
    function (excludeList) {
        if (excludeList === void 0) { excludeList = []; }
        return Object.entries(this.pluginConfigMap)
            .filter((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 1), key = _b[0];
            return !excludeList.includes(key);
        }))
            .reduce((/**
         * @param {?} pluginMap
         * @param {?} __1
         * @return {?}
         */
        function (pluginMap, _a) {
            var _b;
            var _c = __read(_a, 2), key = _c[0], plugin = _c[1];
            return __assign({}, pluginMap, (_b = {}, _b[key] = plugin, _b));
        }), {});
    };
    /**
     * Get a list of plugins, filtering with an include list of plugins
     * @param includeList
     */
    /**
     * Get a list of plugins, filtering with an include list of plugins
     * @param {?=} includeList
     * @return {?}
     */
    NgxEditorJSPluginService.prototype.getPluginsWithInclude = /**
     * Get a list of plugins, filtering with an include list of plugins
     * @param {?=} includeList
     * @return {?}
     */
    function (includeList) {
        if (includeList === void 0) { includeList = []; }
        return Object.entries(this.pluginConfigMap)
            .filter((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 1), key = _b[0];
            return includeList.includes(key);
        }))
            .reduce((/**
         * @param {?} pluginMap
         * @param {?} __1
         * @return {?}
         */
        function (pluginMap, _a) {
            var _b;
            var _c = __read(_a, 2), key = _c[0], plugin = _c[1];
            return __assign({}, pluginMap, (_b = {}, _b[key] = plugin, _b));
        }), {});
    };
    NgxEditorJSPluginService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxEditorJSPluginService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [PluginClasses,] }] }
    ]; };
    /** @nocollapse */ NgxEditorJSPluginService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxEditorJSPluginService_Factory() { return new NgxEditorJSPluginService(ɵɵinject(PluginClasses)); }, token: NgxEditorJSPluginService, providedIn: "root" });
    return NgxEditorJSPluginService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$8 = createPluginConfig;
var NgxPluginServiceModule = /** @class */ (function () {
    function NgxPluginServiceModule() {
    }
    NgxPluginServiceModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: PluginClasses,
                            useFactory: ɵ0$8,
                            deps: [PLUGIN_CONFIG, EDITOR_JS_TOOL_INJECTOR]
                        },
                        NgxEditorJSPluginService
                    ]
                },] }
    ];
    return NgxPluginServiceModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$9 = InlineCode, ɵ1$8 = {
    key: 'inline-code',
    type: PluginTypes.Inline,
    pluginName: 'EditorJS Inline Code',
    shortcut: 'CTRL+SHIFT+C'
};
/**
 * A module that provides the default EditorJS `<p>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
 */
var PluginInlineCodeModule = /** @class */ (function () {
    function PluginInlineCodeModule() {
    }
    PluginInlineCodeModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EDITOR_JS_TOOL_INJECTOR,
                            useValue: ɵ0$9,
                            multi: true
                        },
                        {
                            provide: PLUGIN_CONFIG,
                            useValue: ɵ1$8,
                            multi: true
                        }
                    ]
                },] }
    ];
    return PluginInlineCodeModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * The `NgxEditorjsPluginsModule` provides several additional modules
 * that provide a way to easily plug in block and inline tools for EditorJS.
 *
 * Importing `NgxEditorjsPluginsModule` will include all modules, while it
 * is also possible to import each individual module as required.
 */
var NgxEditorjsPluginsModule = /** @class */ (function () {
    function NgxEditorjsPluginsModule() {
    }
    NgxEditorjsPluginsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        NgxPluginServiceModule,
                        PluginCodeModule,
                        PluginHeaderModule,
                        PluginImageModule,
                        PluginLinkModule,
                        PluginListModule,
                        PluginMarkerModule,
                        PluginParagraphModule,
                        PluginSimpleImageModule,
                        PluginInlineCodeModule
                    ],
                    exports: [
                        NgxPluginServiceModule,
                        PluginCodeModule,
                        PluginHeaderModule,
                        PluginImageModule,
                        PluginLinkModule,
                        PluginListModule,
                        PluginMarkerModule,
                        PluginParagraphModule,
                        PluginSimpleImageModule,
                        PluginInlineCodeModule
                    ]
                },] }
    ];
    return NgxEditorjsPluginsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { EDITOR_JS_TOOL_INJECTOR, NgxEditorJSPluginService, NgxEditorjsPluginsModule, NgxPluginServiceModule, PLUGIN_CONFIG, PluginClasses, PluginCodeModule, PluginHeaderModule, PluginImageModule, PluginInlineCodeModule, PluginLinkModule, PluginListModule, PluginMarkerModule, PluginParagraphModule, PluginSimpleImageModule, PluginTypes, createPluginConfig };
//# sourceMappingURL=tinynodes-ngx-editorjs-plugins.js.map
